<script>
  export let homework
  export let auth
  export let showDeadline
  export let refreshKey

  import DOMPurify from 'dompurify'

  import {
    EditOutline,
    TrashOutline,
    RewindLeft,
    ClockOutline,
    ImageOutline,
    MoreHorizontal,
  } from '../assets/icons'

  import { setToast } from '../stores/toast'
  import offline from '../stores/offline'

  import getDate from '../utils/getDate'

  import { compressImage } from 'imgcomp'

  import { updateHomework } from '../api/homeworks'
  import { uploadHomeworkResource } from '../api/homeworkResources'

  import ModalMenu from './ModalMenu'
  import ModalSimple from './ModalSimple'
  import Progress from './Progress'
  import HomeworkResourcesPreview from './HomeworkResourcesPreview/fromApi'

  const dateFormatter = new Intl.RelativeTimeFormat('es', { numeric: 'auto' })

  $: relativeDeadline =
    homework.deadline_date &&
    dateFormatter.format(
      Math.floor(
        (getDate(homework.deadline_date) - new Date()) / 1000 / 60 / 60 / 24,
      ) + 1,
      'day',
    )

  function archive() {
    return updateHomework(
      {
        id: homework.id,
        archived: true,
      },
      auth.secret,
    )
      .then(() => {
        setToast('Esa tarea fue borrada.', [
          {
            text: 'Deshacer',
            fn: () =>
              updateHomework(
                {
                  id: homework.id,
                  archived: false,
                },
                auth.secret,
              ),
          },
        ])
      })
      .catch(() => {
        setToast('Hubo un problema borrando esa tarea.')
      })
  }
  function unarchive() {
    return updateHomework(
      {
        id: homework.id,
        archived: false,
      },
      auth.secret,
    )
  }

  let uploadEl
  function openUploadDialog() {
    uploadEl.click()
  }

  let uploadProgress = null
  let cancelFn
  async function upload(event) {
    try {
      const file = event.target.files[0]
      const compressedFile = await compressImage(file)

      const [promise, cancel] = uploadHomeworkResource({
        homeworkId: homework.id,
        auth,
        onProgressFn: progress => (uploadProgress = progress),
        file: compressedFile,
      })

      cancelFn = () => {
        uploadProgress = null
        setToast('Hubo un problema subiendo ese recurso.')
        cancel()
      }

      await promise
    } catch (error) {
      setToast('Hubo un problema subiendo ese recurso.')
      console.error(error)
    }
    uploadProgress = null
  }

  let text
  $: {
    const step1 = homework.text
      .split('\n')
      .map((paragraph, index, array) =>
        paragraph.length < 1
          ? '<br />'
          : `<p class="${array.length - 1 === index ? '' : 'pb-1 '}leading-snug">${paragraph}</p>`,
      )
      .join('')

    const links = homework.text.match(/https?:\/\/\S+/gi)
    let step2 = step1
    if (links) {
      for (const link of links) {
        step2 = step2.replace(
          link,
          `<a class="link" href="${link}">${link}</a>`,
        )
      }
    }

    text = DOMPurify.sanitize(step2, {
      ALLOWED_TAGS: ['p', 'a', 'br', '#text'],
    })
  }

  let overlayEnabled = false
</script>

<input
  bind:this={uploadEl}
  type="file"
  class="hidden"
  accept="image/*"
  on:change={upload}
/>

{#if uploadProgress !== null}
  <ModalSimple>
    <h3 class="text-2xl text-center">Subiendo recurso...</h3>
    <Progress progress={uploadProgress} />
    <button class="btn btn-outlined mx-auto mt-2" on:click={cancelFn}>
      Cancelar
    </button>
  </ModalSimple>
{/if}

{#if overlayEnabled}
  <ModalMenu closeFn={e => (overlayEnabled = false)}>
    <button
      class="modal-menu-btn"
      disabled={$offline}
      on:click={() => (location.hash = `#/groups/${homework.group_id}/homeworks/${homework.id}/edit`)}
    >
      <span class="icon mr-2">
        <EditOutline />
      </span>
      Editar
    </button>
    <button
      class="modal-menu-btn"
      disabled={$offline}
      on:click={homework.archived ? unarchive : archive}
    >
      {#if homework.archived}
        <span class="icon mr-2">
          <RewindLeft />
        </span>
        Restaurar
      {:else}
        <span class="icon mr-2">
          <TrashOutline />
        </span>
        Borrar
      {/if}
    </button>
    <button
      class="modal-menu-btn"
      disabled={$offline}
      on:click={openUploadDialog}
    >
      <span class="icon mr-2">
        <ImageOutline />
      </span>
      Subir recurso
    </button>
  </ModalMenu>
{/if}

<div class="border border-gray-400 bg-white dark:border-gray-700 dark:bg-gray-800 rounded p-2 my-2">
  <button
    class="float-right"
    aria-label="más opciones"
    on:click={e => (overlayEnabled = true)}
  >
    <MoreHorizontal props={{ class: 'h-7 w-10', 'aria-hidden': 'true' }} />
  </button>
  {#if homework.deadline_date && showDeadline}
    <p class="flex items-center text-gray-700 dark:text-gray-500">
      <ClockOutline
        props={{ class: 'h-5 mr-2', 'aria-label': 'fecha de entrega' }}
      />
      {relativeDeadline}
    </p>
  {/if}
  <div class="text-lg raw-content break-words">
    {@html text}
  </div>
  <HomeworkResourcesPreview
    homeworkId={homework.id}
    groupId={homework.group_id}
    {refreshKey}
  />
</div>
